Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.bidimap
Class AbstractOrderedBidiMapDecorator

    java.lang.Object
      |
      +--org.apache.commons.collections.map.AbstractMapDecorator
            |
            +--org.apache.commons.collections.bidimap.AbstractBidiMapDecorator
                  |
                  +--org.apache.commons.collections.bidimap.AbstractOrderedBidiMapDecorator

All Implemented Interfaces:
  BidiMap, IterableMap, Map, OrderedBidiMap, OrderedMap

Direct Known Subclasses:
  AbstractSortedBidiMapDecorator, UnmodifiableOrderedBidiMap

public abstract class AbstractOrderedBidiMapDecorator
extends AbstractBidiMapDecorator
implements OrderedBidiMap

Provides a base decorator that enables additional functionality to be added to an OrderedBidiMap via decoration.

Methods are forwarded directly to the decorated map.

This implementation does not perform any special processing with the map views. Instead it simply returns the inverse from the wrapped map. This may be undesirable, for example if you are trying to write a validating implementation it would provide a loophole around the validation. But, you might want that loophole, so this class is kept simple.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.4 $ $Date: 2004/02/18 00:57:39 $
Author:
  Stephen Colebourne

Field Summary

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` | `AbstractOrderedBidiMapDecorator(OrderedBidiMap map)` Constructor that wraps (not copies).

Method Summary
`Object` | `firstKey()` Gets the first key currently in this map.
`protected OrderedBidiMap` | `getOrderedBidiMap()` Gets the map being decorated.
`OrderedBidiMap` | `inverseOrderedBidiMap()` Gets a view of this map where the keys and values are reversed.
`Object` | `lastKey()` Gets the last key currently in this map.
`Object` | `nextKey(Object key)` Gets the next key after the one specified.
`OrderedMapIterator` | `orderedMapIterator()` Obtains an `OrderedMapIterator` over the map.
`Object` | `previousKey(Object key)` Gets the previous key before the one specified.

Methods inherited from class org.apache.commons.collections.bidimap.AbstractBidiMapDecorator
`getBidiMap, getKey, inverseBidiMap, mapIterator, removeValue`

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, entrySet, equals, get, getMap, hashCode, isEmpty, keySet, put, putAll, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.OrderedBidiMap
`inverseBidiMap`

Methods inherited from interface org.apache.commons.collections.BidiMap
`getKey, mapIterator, put, removeValue`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, putAll, remove, size, values`

Constructor Detail

### AbstractOrderedBidiMapDecorator

    protected AbstractOrderedBidiMapDecorator(OrderedBidiMap map)

  Constructor that wraps (not copies).

Parameters:
  `map` - the map to decorate, must not be null
Throws:
  `IllegalArgumentException` - if the collection is null

Method Detail

### getOrderedBidiMap

    protected OrderedBidiMap getOrderedBidiMap()

  Gets the map being decorated.

  Returns:
    the decorated map

### orderedMapIterator

    public OrderedMapIterator orderedMapIterator()

  Description copied from interface: `OrderedMap`
  Obtains an `OrderedMapIterator` over the map.

  A ordered map iterator is an efficient way of iterating over maps in both directions.

       BidiMap map = new TreeBidiMap();
       MapIterator it = map.mapIterator();
       while (it.hasNext()) {
         Object key = it.next();
         Object value = it.getValue();
         it.setValue("newValue");
         Object previousKey = it.previous();
       }

  Specified by:
    `orderedMapIterator` in interface `OrderedMap`
  Returns:
    a map iterator

### firstKey

    public Object firstKey()

  Description copied from interface: `OrderedMap`
  Gets the first key currently in this map.

  Specified by:
    `firstKey` in interface `OrderedMap`
  Returns:
    the first key currently in this map

### lastKey

    public Object lastKey()

  Description copied from interface: `OrderedMap`
  Gets the last key currently in this map.

  Specified by:
    `lastKey` in interface `OrderedMap`
  Returns:
    the last key currently in this map

### nextKey

    public Object nextKey(Object key)

  Description copied from interface: `OrderedMap`
  Gets the next key after the one specified.

  Specified by:
    `nextKey` in interface `OrderedMap`
  Parameters:
    `key` - the key to search for next from
  Returns:
    the next key, null if no match or at end

### previousKey

    public Object previousKey(Object key)

  Description copied from interface: `OrderedMap`
  Gets the previous key before the one specified.

  Specified by:
    `previousKey` in interface `OrderedMap`
  Parameters:
    `key` - the key to search for previous from
  Returns:
    the previous key, null if no match or at start

### inverseOrderedBidiMap

    public OrderedBidiMap inverseOrderedBidiMap()

  Description copied from interface: `OrderedBidiMap`
  Gets a view of this map where the keys and values are reversed.

  Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed equally.

  Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

  Specified by:
    `inverseOrderedBidiMap` in interface `OrderedBidiMap`
  Returns:
    an inverted bidirectional map

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2004 Apache Software Foundation. All Rights Reserved.